#include <xmdv/ogl.h>
#include <xmdv/CDisplay.h>
#include <xmdv/XmdvTool.h>
#include <xmdv/colormap.h>
#include <xmdv/magnify.h>
#include <xmdv/brush_oper.h>
//#include <backend/db_prefetch.h>


CDisplay::CDisplay()
{
	xor_needs_undo = false;
	input_mode = NONE;
}


CDisplay::~CDisplay()
{
}

//some display requires minimum dimensionality, reture true if there is enough dimensions.
bool CDisplay::TestDimensionality()  
{
	return true;
}


void CDisplay::CanvasDraw()
{
	if ( ! dataset || dataset->datafile == NULL )
		return;
	if ( TestDimensionality() )
		Draw();
}


void CDisplay::CanvasInputKeyPress(int key)
{
	if ( ! dataset )
		return;
	if ( TestDimensionality() )
		InputKeyPress(key);
}


void CDisplay::CanvasInputKeyRelease(int key)
{
	if ( ! dataset )
		return;
	if ( TestDimensionality() )
		InputKeyRelease(key);
}


void CDisplay::CanvasInputMouseMotion(int x, int y)
{
	if ( ! dataset )
		return;
	if ( TestDimensionality() )
		InputMouseMotion(x, y);
}


void CDisplay::CanvasInputButtonPress(int button, int x, int y)
{
	if ( ! dataset )
		return;
	if ( TestDimensionality() )
		InputButtonPress(button, x, y);
}


void CDisplay::CanvasInputButtonRelease(int button, int x, int y)
{
	if ( ! dataset )
		return;
	if ( TestDimensionality() )
		InputButtonRelease(button, x, y);
}


void CDisplay::Reshape()
{
    canvas->grResizeMainCanvas(canvas);
}


void CDisplay::Draw()
{
}



void CDisplay::InputKeyPress(int key)
{
//    appCanvasInputKeyPress(canvas, key);
}


void CDisplay::InputKeyRelease(int key)
{
//    appCanvasInputKeyRelease(canvas, key);
}


void CDisplay::InputMouseMotion(int x, int y)
{
}


void CDisplay::InputButtonPress(int button, int x, int y)
{
}


void CDisplay::InputButtonRelease(int button, int x, int y)
{
}


void CDisplay::SetCanvas(grCanvas *canvas)
{
    this->canvas = canvas;
}


void CDisplay::PrepareCanvas()
{
    canvas->SetTopLeftOrigin();
    grCanvas::grResizeMainCanvas(canvas);

    canvas->SetBackground(interface_color[BG]);
    canvas->Clear();
}
