#include <xmdv/CHierDisplayInformation.h>
#include <xmdv/XmdvTool.h>
#include <string.h>

CHierDisplayInformation::CHierDisplayInformation()
{
	Reset();
}

void CHierDisplayInformation::Reset()
{
	cluster_radius = 0.5;
	brushed_radius= 0.5;
	fade_factor=0; // [-1,+1]
	extent_scaling_fac=1.0;
	density = 0.5;

	SHOW_BANDS = false;//show_bands

	SHOW_MEANS = true;
	SHOW_BRUSH_BKGRD = true;
	COLORED_BANDS = true;

	normal_style = STYLE_COLORMAP;
	highlight_style = STYLE_HIGHLIGHT | STYLE_THICK;

	tree_brush[0] = .25;
	tree_brush[1] = .75;
	tree_height=0;

    CMAP = colormap(true);

	database = false;

	SetBackend(backend);

}

void CHierDisplayInformation::SetBackend(bool backend)
{
	if ( dataset )
	{
		if ( backend && strstr(dataset->datafile, "synt") )
			database = true;
		else 
			database = false;
	}
}